XSElementDeclaration (XML Schema API)
Date: 2018-10-16

org.apache.xerces.xs

## Interface XSElementDeclaration

- All Superinterfaces:
    XSObject, XSTerm

      public interface XSElementDeclaration
      extends XSTerm

  The interface represents the Element Declaration schema component.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `getAbstract()` {abstract} A boolean.
    `java.lang.Object` | `getActualVC()` Deprecated. Use getValueConstraintValue().getActualValue() instead
    `short` | `getActualVCType()` Deprecated. Use getValueConstraintValue().getActualValueType() instead
    `XSAnnotation` | `getAnnotation()` An annotation if it exists, otherwise `null`.
    `XSObjectList` | `getAnnotations()` A sequence of [annotations] or an empty `XSObjectList`.
    `short` | `getConstraintType()` [Value constraint]: one of `VC_NONE, VC_DEFAULT, VC_FIXED`.
    `java.lang.String` | `getConstraintValue()` Deprecated. Use getValueConstraintValue().getNormalizedValue() instead
    `short` | `getDisallowedSubstitutions()` [disallowed substitutions]: the returned value is a bit combination of the subset of { `DERIVATION_SUBSTITUTION, DERIVATION_EXTENSION, DERIVATION_RESTRICTION` } corresponding to substitutions disallowed by this `XSElementDeclaration` or `DERIVATION_NONE`.
    `XSComplexTypeDefinition` | `getEnclosingCTDefinition()` The complex type definition for locally scoped declarations (see `scope`), otherwise `null` if no such definition exists.
    `XSNamedMap` | `getIdentityConstraints()` identity-constraint definitions: a set of constraint definitions if it exists, otherwise an empty `XSNamedMap`.
    `ShortList` | `getItemValueTypes()` Deprecated. Use getValueConstraintValue().getListValueTypes() instead
    `boolean` | `getNillable()` If nillable is true, then an element may also be valid if it carries the namespace qualified attribute with local name `nil` from namespace `http://www.w3.org/2001/XMLSchema-instance` and value `true` (xsi:nil) even if it has no text or element content despite a `content type` which would otherwise require content.
    `short` | `getScope()` [scope].
    `XSElementDeclaration` | `getSubstitutionGroupAffiliation()` [substitution group affiliation]: a top-level element definition if it exists, otherwise `null`.
    `short` | `getSubstitutionGroupExclusions()` [substitution group exclusions]: the returned value is a bit combination of the subset of { `DERIVATION_EXTENSION, DERIVATION_RESTRICTION`} or `DERIVATION_NONE`.
    `XSTypeDefinition` | `getTypeDefinition()` [type definition]: either a simple type definition or a complex type definition.
    `XSValue` | `getValueConstraintValue()` The actual value of the default or fixed value constraint.
    `boolean` | `isDisallowedSubstitution(short disallowed)` Convenience method that checks if `disallowed` is a disallowed substitution for this element declaration.
    `boolean` | `isSubstitutionGroupExclusion(short exclusion)` Convenience method that checks if `exclusion` is a substitution group exclusion for this element declaration.

    - ### Methods inherited from interface org.apache.xerces.xs.XSObject

      `getName, getNamespace, getNamespaceItem, getType`

- - ### Method Detail

    - #### getTypeDefinition

          XSTypeDefinition getTypeDefinition()

      [type definition]: either a simple type definition or a complex type definition.

    - #### getScope

          short getScope()

      [scope]. One of `SCOPE_GLOBAL`, `SCOPE_LOCAL`, or `SCOPE_ABSENT`. If the scope is local, then the `enclosingCTDefinition` is present.

    - #### getEnclosingCTDefinition

          XSComplexTypeDefinition getEnclosingCTDefinition()

      The complex type definition for locally scoped declarations (see `scope`), otherwise `null` if no such definition exists.

    - #### getConstraintType

          short getConstraintType()

      [Value constraint]: one of `VC_NONE, VC_DEFAULT, VC_FIXED`.

    - #### getConstraintValue

          java.lang.String getConstraintValue()

      Deprecated. Use getValueConstraintValue().getNormalizedValue() instead
      [Value constraint]: the constraint value with respect to the [type definition], otherwise `null`.

    - #### getActualVC

          java.lang.Object getActualVC()
                                throws XSException

      Deprecated. Use getValueConstraintValue().getActualValue() instead
      Value Constraint: Binding specific actual constraint value or `null` if the value is in error or there is no value constraint.
      Throws:
        `XSException` - NOT_SUPPORTED_ERR: Raised if the implementation does not support this method.

    - #### getActualVCType

          short getActualVCType()
                         throws XSException

      Deprecated. Use getValueConstraintValue().getActualValueType() instead
      The actual constraint value built-in datatype, e.g. `STRING_DT, SHORT_DT`. If the type definition of this value is a list type definition, this method returns `LIST_DT`. If the type definition of this value is a list type definition whose item type is a union type definition, this method returns `LISTOFUNION_DT`. To query the actual constraint value of the list or list of union type definitions use `itemValueTypes`. If the `actualNormalizedValue` is `null`, this method returns `UNAVAILABLE_DT`.
      Throws:
        `XSException` - NOT_SUPPORTED_ERR: Raised if the implementation does not support this method.

    - #### getItemValueTypes

          ShortList getItemValueTypes()
                               throws XSException

      Deprecated. Use getValueConstraintValue().getListValueTypes() instead
      In the case the actual constraint value represents a list, i.e. the `actualValueType` is `LIST_DT`, the returned array consists of one type kind which represents the itemType. If the actual constraint value represents a list type definition whose item type is a union type definition, i.e. `LISTOFUNION_DT`, for each actual constraint value in the list the array contains the corresponding memberType kind. For examples, see `ItemPSVI.itemValueTypes`.
      Throws:
        `XSException` - NOT_SUPPORTED_ERR: Raised if the implementation does not support this method.

    - #### getValueConstraintValue

          XSValue getValueConstraintValue()

      The actual value of the default or fixed value constraint.

    - #### getNillable

          boolean getNillable()

      If nillable is true, then an element may also be valid if it carries the namespace qualified attribute with local name `nil` from namespace `http://www.w3.org/2001/XMLSchema-instance` and value `true` (xsi:nil) even if it has no text or element content despite a `content type` which would otherwise require content.

    - #### getIdentityConstraints

          XSNamedMap getIdentityConstraints()

      identity-constraint definitions: a set of constraint definitions if it exists, otherwise an empty `XSNamedMap`.

    - #### getSubstitutionGroupAffiliation

          XSElementDeclaration getSubstitutionGroupAffiliation()

      [substitution group affiliation]: a top-level element definition if it exists, otherwise `null`.

    - #### isSubstitutionGroupExclusion

          boolean isSubstitutionGroupExclusion(short exclusion)

      Convenience method that checks if `exclusion` is a substitution group exclusion for this element declaration.
      Parameters:
        `exclusion` - `DERIVATION_EXTENSION, DERIVATION_RESTRICTION` or `DERIVATION_NONE`. Represents final set for the element.
      Returns:
        True if `exclusion` is a part of the substitution group exclusion subset.

    - #### getSubstitutionGroupExclusions

          short getSubstitutionGroupExclusions()

      [substitution group exclusions]: the returned value is a bit combination of the subset of { `DERIVATION_EXTENSION, DERIVATION_RESTRICTION`} or `DERIVATION_NONE`.

    - #### isDisallowedSubstitution

          boolean isDisallowedSubstitution(short disallowed)

      Convenience method that checks if `disallowed` is a disallowed substitution for this element declaration.
      Parameters:
        `disallowed` - { `DERIVATION_SUBSTITUTION, DERIVATION_EXTENSION, DERIVATION_RESTRICTION` } or `DERIVATION_NONE`. Represents a block set for the element.
      Returns:
        True if `disallowed` is a part of the substitution group exclusion subset.

    - #### getDisallowedSubstitutions

          short getDisallowedSubstitutions()

      [disallowed substitutions]: the returned value is a bit combination of the subset of { `DERIVATION_SUBSTITUTION, DERIVATION_EXTENSION, DERIVATION_RESTRICTION` } corresponding to substitutions disallowed by this `XSElementDeclaration` or `DERIVATION_NONE`.

    - #### getAbstract

          boolean getAbstract()

      {abstract} A boolean.

    - #### getAnnotation

          XSAnnotation getAnnotation()

      An annotation if it exists, otherwise `null`. If not null then the first [annotation] from the sequence of annotations.

    - #### getAnnotations

          XSObjectList getAnnotations()

      A sequence of [annotations] or an empty `XSObjectList`.

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.